
//////////////////////////////////////////////////////
//                 GLOBAL VARIABLES                 //
//////////////////////////////////////////////////////

var dimension = 3;

var X = new Array(new Array(0, 2*Math.PI), new Array(-20, 20), new Array(-20, 20));

var epsilon = 0.0000000001;



//////////////////////////////////////////////////////
//                 LOCAL VARIABLES                 //
//////////////////////////////////////////////////////

var s = 200;

var A = new Array(s);
var B = new Array(s);

var random_input = false; // true = create random input data



//////////////////////////////////////////////////////
//                   CALCULATIONS                   //
//////////////////////////////////////////////////////

// transformation function //

function T (x, A) {
  var cos = Math.cos(x[0]);
  var sin = Math.sin(x[0]);
  return new Array(cos*A[0] + sin*A[1] + x[1], -sin*A[0] + cos*A[1] + x[2]);
}

// initialize problem //

function add_random () {
  var sigma = 0.5;
  return Math.random()*sigma - sigma/2;
}

function init_problem () {
  if (random_input == true) {
    var a = 2*Math.PI*Math.random();
    var b = 20*Math.random()-10;
    var c = 20*Math.random()-10;
    for (var k = 0; k < A.length; k++) {
      B[k] = new Array(20*Math.random()-10, 20*Math.random()-10);
      A[k] = T(new Array(a, b, c), B[k]);
      A[k] = new Array(A[k][0]+add_random(), A[k][1]+add_random());
    }
  } else {
    s = 50;
    A = new Array();
    B = new Array();

    A.push(new Array(-6.092, 3.402));
    A.push(new Array(4.550, -15.227));
    A.push(new Array(2.195, -8.907));
    A.push(new Array(3.798, -0.970));
    A.push(new Array(-6.157, -11.672));
    A.push(new Array(9.872, -10.642));
    A.push(new Array(-5.483, -8.103));
    A.push(new Array(10.456, -5.621));
    A.push(new Array(2.083, -5.388));
    A.push(new Array(14.127, 0.490));
    A.push(new Array(-7.664, -2.132));
    A.push(new Array(-0.484, 0.643));
    A.push(new Array(-5.846, 1.155));
    A.push(new Array(3.526, -5.281));
    A.push(new Array(3.683, -2.821));
    A.push(new Array(0.437, 3.533));
    A.push(new Array(4.605, 2.936));
    A.push(new Array(-0.339, -2.737));
    A.push(new Array(9.730, -8.734));
    A.push(new Array(10.578, -13.371));
    A.push(new Array(5.768, 2.677));
    A.push(new Array(4.259, -7.618));
    A.push(new Array(5.710, -0.168));
    A.push(new Array(8.535, -9.971));
    A.push(new Array(-2.739, -9.571));
    A.push(new Array(-1.063, -15.036));
    A.push(new Array(-0.369, -4.779));
    A.push(new Array(11.890, -6.501));
    A.push(new Array(1.475, 0.669));
    A.push(new Array(14.005, -3.581));
    A.push(new Array(6.335, -4.134));
    A.push(new Array(-2.834, 3.126));
    A.push(new Array(8.882, -12.169));
    A.push(new Array(2.221, 7.186));
    A.push(new Array(14.382, -6.367));
    A.push(new Array(-0.599, -10.065));
    A.push(new Array(-4.556, -4.265));
    A.push(new Array(-7.919, -3.979));
    A.push(new Array(-4.206, 2.434));
    A.push(new Array(9.109, -3.648));
    A.push(new Array(-3.236, -14.079));
    A.push(new Array(1.034, -4.046));
    A.push(new Array(13.394, -1.556));
    A.push(new Array(-2.710, -6.787));
    A.push(new Array(9.157, -5.727));
    A.push(new Array(6.943, 1.536));
    A.push(new Array(13.463, -11.028));
    A.push(new Array(-0.614, 2.435));
    A.push(new Array(-1.897, -8.513));
    A.push(new Array(14.788, -1.850));

    B.push(new Array(-2.625, -11.583));
    B.push(new Array(9.868, 6.188));
    B.push(new Array(4.593, 1.157));
    B.push(new Array(-2.825, -0.724));
    B.push(new Array(10.899, -5.282));
    B.push(new Array(2.875, 8.829));
    B.push(new Array(7.206, -6.174));
    B.push(new Array(-1.507, 7.845));
    B.push(new Array(1.492, -0.082));
    B.push(new Array(-8.727, 8.337));
    B.push(new Array(3.034, -10.757));
    B.push(new Array(-2.681, -4.667));
    B.push(new Array(-1.334, -10.087));
    B.push(new Array(1.083, 1.372));
    B.push(new Array(-1.387, -0.105));
    B.push(new Array(-6.183, -5.402));
    B.push(new Array(-6.909, -1.712));
    B.push(new Array(0.565, -3.469));
    B.push(new Array(1.548, 7.792));
    B.push(new Array(5.347, 10.934));
    B.push(new Array(-7.451, -0.131));
    B.push(new Array(2.614, 2.646));
    B.push(new Array(-4.413, 1.061));
    B.push(new Array(2.925, 7.339));
    B.push(new Array(7.588, -2.602));
    B.push(new Array(11.752, 0.771));
    B.push(new Array(2.226, -3.036));
    B.push(new Array(-1.606, 9.455));
    B.push(new Array(-3.867, -3.441));
    B.push(new Array(-5.245, 9.814));
    B.push(new Array(-1.137, 3.546));
    B.push(new Array(-3.726, -8.156));
    B.push(new Array(4.848, 8.678));
    B.push(new Array(-10.225, -5.291));
    B.push(new Array(-2.418, 11.139));
    B.push(new Array(7.430, -0.828));
    B.push(new Array(3.372, -6.997));
    B.push(new Array(4.582, -9.661));
    B.push(new Array(-3.064, -9.704));
    B.push(new Array(-2.915, 5.015));
    B.push(new Array(12.047, -1.312));
    B.push(new Array(0.564, -1.736));
    B.push(new Array(-6.262, 8.338));
    B.push(new Array(5.070, -3.586));
    B.push(new Array(-0.719, 6.508));
    B.push(new Array(-6.506, 1.029));
    B.push(new Array(1.959, 12.088));
    B.push(new Array(-4.259, -5.523));
    B.push(new Array(5.820, -2.332));
    B.push(new Array(-6.994, 9.567));
  }
}

// objective function //

function distance_sq (x, A, B) {
  var R = T(x, A);
  return (R[0]-B[0])*(R[0]-B[0]) + (R[1]-B[1])*(R[1]-B[1]);
}

function f (x) {
  var sum = 0;
  for (var k = 0; k < A.length; k++) sum += distance_sq(x, A[k], B[k]);
  return sum;
}

// lower bounds //

function list_min (L) {
  var h = L[0];
  for (var i = 1; i < L.length; i++) if (L[i] < h) h = L[i];
  return h;
}

function LB (I) {
  var cos = IA.cos(I[0]);
  var sin = IA.sin(I[0]);
  var l = new Array(I[0][0], I[1][0], I[2][0]);
  var V = new Array(0,0,0,0,0,0,0,0);

  for (var k = 0; k < A.length; k++) {
    var AA = A[k];
    var BB = B[k];
    var Sum1 = IA.add_scalar(-BB[0], IA.add( IA.add( IA.mult_scalar(AA[0], cos), IA.mult_scalar(AA[1], sin) ), I[1] ) );
    var Sum2 = IA.add_scalar(-BB[1], IA.add( IA.add( IA.mult_scalar(-AA[0], sin), IA.mult_scalar(AA[1], cos) ), I[2] ) );
    var G1 = IA.mult_scalar(2, Sum1);
    var G2 = IA.mult_scalar(2, Sum2);
    var H1 = IA.add( IA.mult_scalar(-AA[0], sin), IA.mult_scalar(AA[1], cos) );
    var H2 = IA.add( IA.mult_scalar(-AA[0], cos), IA.mult_scalar(-AA[1], sin) );
    var G0 = IA.add( IA.mult(G1, H1), IA.mult(G2, H2) );

    var fl = distance_sq(l, AA, BB);
  
    V[0] += fl + G0[0]*(I[0][0]-l[0]) + G1[0]*(I[1][0]-l[1]) + G2[0]*(I[2][0]-l[2]);
    V[1] += fl + G0[0]*(I[0][0]-l[0]) + G1[0]*(I[1][0]-l[1]) + G2[0]*(I[2][1]-l[2]);
    V[2] += fl + G0[0]*(I[0][0]-l[0]) + G1[0]*(I[1][1]-l[1]) + G2[0]*(I[2][0]-l[2]);
    V[3] += fl + G0[0]*(I[0][0]-l[0]) + G1[0]*(I[1][1]-l[1]) + G2[0]*(I[2][1]-l[2]);
    V[4] += fl + G0[0]*(I[0][1]-l[0]) + G1[0]*(I[1][0]-l[1]) + G2[0]*(I[2][0]-l[2]);
    V[5] += fl + G0[0]*(I[0][1]-l[0]) + G1[0]*(I[1][0]-l[1]) + G2[0]*(I[2][1]-l[2]);
    V[6] += fl + G0[0]*(I[0][1]-l[0]) + G1[0]*(I[1][1]-l[1]) + G2[0]*(I[2][0]-l[2]);
    V[7] += fl + G0[0]*(I[0][1]-l[0]) + G1[0]*(I[1][1]-l[1]) + G2[0]*(I[2][1]-l[2]);
  }
  
  return list_min(V);
}



//////////////////////////////////////////////////////
//              PROBLEM VISUALIZATION               //
//////////////////////////////////////////////////////

function plot_problem (current_solution) {
  PV.set_size(-15, 15, -15, 15, 1);

  for (var k = 0; k < A.length; k++) {
    var H = T(current_solution, A[k]);
    PV.disc(B[k][0], B[k][1], 0.2, '#DE102D');
    PV.disc(H[0], H[1], 0.2, '#0059C5');
  }

  PV.text(-10.8, 13.6, A.length + " demand points");
  PV.head("Problem Visualization");
}
